<template>
  <div ref="gameContainer" class="game-container"></div>
</template>

<script>
import Phaser from 'phaser';
import GameScene from "@/Game/scenes/GameScene.js";
import GameOverScene  from "@/Game/scenes/GameOverScene.js"

export default {
  name: 'PhaserGame',
  data() {
    return {
      game: null
    };
  },
  mounted() {
    this.initializePhaser();
    this.$refs.gameContainer.focus();
  },
  beforeDestroy() {
    this.destroyPhaser();
  },
  beforeRouteEnter(to, from, next) {
    this.destroyPhaser();
    next(vm => vm.initializePhaser());
  },
  beforeRouteLeave(to, from, next) {
    this.destroyPhaser();
    next();
  },
  methods: {
    initializePhaser() {
      const config = {
        type: Phaser.AUTO,
        width: 1530,
        height: 550,
        scene: [GameScene, GameOverScene],
        physics: {
          default: "arcade",
          arcade: {
            gravity: {y: 10000},
            debug: false,
          }
        },
        // scale: {
        //   mode: Phaser.Scale.RESIZE,
        //   autoCenter: Phaser.Scale.CENTER_BOTH
        // },
        parent: this.$refs.gameContainer
      };
      this.game = new Phaser.Game(config);
    },
    destroyPhaser() {
      if (this.game) {
        this.game.destroy(true);
        this.game = null;
      }
    },
    // gameOver() {
    //   if (this.cursors.down.isDown) {
    //     this.scene.start("GameOverScene")
    //   }
    // }
  }
}
</script>

<style scoped>
.game-container {
  width: 100%;
  height: 100%;
}
</style>